﻿package supermotion3d
{
	import flash.display.Sprite;
	import flash.geom.Matrix3D;
	import flash.geom.Vector3D;

	public class Matrix3DEx extends Sprite
	{
		public var _matrix:Matrix3D = new Matrix3D();
		private var _rotation:Vector3D = new Vector3D();
		private var _scale:Vector3D = new Vector3D(1,1,1);

		public function get positionX():Number
		{
			return this._matrix.position.x;
		}
		public function set positionX( value:Number ):void
		{
			this._matrix.position = new Vector3D(
				value,this._matrix.position.y,this._matrix.position.z);
		}

		public function get positionY():Number
		{
			return this._matrix.position.y;
		}
		public function set positionY( value:Number ):void
		{
			this._matrix.position = new Vector3D(
				this._matrix.position.x,value,this._matrix.position.z);
		}

		public function get positionZ():Number
		{
			return this._matrix.position.z;
		}
		public function set positionZ( value:Number ):void
		{
			this._matrix.position = new Vector3D(
				this._matrix.position.x,this._matrix.position.y,value);
		}

		public function get position():Vector3D
		{
			return this._matrix.position;
		}
		public function set position( value:Vector3D ):void
		{
			this._matrix.position = value;
		}

		public function get rotateX():Number
		{
			return this._rotation.x;
		}
		public function set rotateX( value:Number ):void
		{
			this._rotation.x = value;
		}

		public function get rotateY():Number
		{
			return this._rotation.y;
		}
		public function set rotateY( value:Number ):void
		{
			this._rotation.y = value;
		}

		public function get rotateZ():Number
		{
			return this._rotation.z;
		}
		public function set rotateZ( value:Number ):void
		{
			this._rotation.z = value;
		}

		public function get rotate():Vector3D
		{
			return this._rotation;
		}
		public function set rotate( value:Vector3D ):void
		{
			this._rotation = value;
		}

		public function get scalingX():Number
		{
			return this._scale.x;
		}
		public function set scalingX( value:Number ):void
		{
			this._scale.x = value;
		}

		public function get scalingY():Number
		{
			return this._scale.y;
		}
		public function set scalingY( value:Number ):void
		{
			this._scale.y = value;
		}

		public function get scalingZ():Number
		{
			return this._scale.z;
		}
		public function set scalingZ( value:Number ):void
		{
			this._scale.z = value;
		}

		public function get scaling():Vector3D
		{
			return this._scale;
		}
		public function set scaling( value:Vector3D ):void
		{
			this._scale = value;
		}

		public function updateMatrix():void
		{
			setMatrix(this._matrix.position,this._rotation,this._scale);
		}

		public function setMatrix(trans:Vector3D,rotate:Vector3D,scale:Vector3D):void
		{
			_matrix.identity();
			_matrix.prependTranslation(trans.x, trans.y, trans.z);
			_matrix.prependRotation(rotate.x, Vector3D.X_AXIS);
			_matrix.prependRotation(rotate.y, Vector3D.Y_AXIS);
			_matrix.prependRotation(rotate.z, Vector3D.Z_AXIS);
			_matrix.prependScale(scale.x, scale.y, scale.z);
		}

		public function getMatrix():Matrix3D
		{
			return _matrix.clone();
		}
	}
}